SystemOrganization addCategory: #PullUpToSuperclass!

Object subclass: #PullUpMethodsToSuperclass
	instanceVariableNames: 'commonSelectors commonSuperclass classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PullUpToSuperclass'!

!PullUpMethodsToSuperclass methodsFor: 'accessing' stamp: 'HwaJong 12/2/2013 14:59'!
classes: anArray 
	classes := anArray ! !

!PullUpMethodsToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 12/2/2013 15:01'!
commitMoveCommonMethods

	commonSelectors do: [:sel| 
		|code cats|
		cats := (classes collect: [:cls| (cls compiledMethodAt: sel) category ]) copyWithoutAll: { #'as yet unclassified'}.
		code := classes anyOne sourceCodeAt: sel.
		commonSuperclass compile: code classified: (cats isEmpty ifTrue: [ #'as yet unclassified'] ifFalse: [cats asBag sortedCounts first value]).
		classes do: [:cls| cls removeSelector: sel]].! !

!PullUpMethodsToSuperclass methodsFor: 'accessing' stamp: 'HwaJong 12/2/2013 14:59'!
commonSuperclass: aClass
	commonSuperclass := aClass! !

!PullUpMethodsToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 12/2/2013 14:59'!
getCommonSelectors

	self precollectCommonSelectors.
	self rejectTraitMethods.
	self selectSelectorsSourceCodeOfAllSubclassesAreSame.
	self rejectSelectorsIfSourceCodeOfSuperclassAndSubclassIsDifferent.! !

!PullUpMethodsToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 12/2/2013 16:50'!
initializeCommonSelectorsFromClasses
	|selectorsOfClasses|
	selectorsOfClasses := classes collect: [ :cls| cls selectors ].
	commonSelectors := selectorsOfClasses inject: (selectorsOfClasses anyOne) into: [:cs :selectors| cs intersection: selectors].! !

!PullUpMethodsToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 12/2/2013 14:59'!
moveMethods

	self getCommonSelectors.
	self commitMoveCommonMethods.! !

!PullUpMethodsToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 12/2/2013 16:59'!
precollectCommonSelectors

	"Think about using CompiledMethodFilter of Sieve here."
	self initializeCommonSelectorsFromClasses.
	self rejectSuperSendingSelectors.
	self rejectSelectorsHavingPragmas.
	self rejectSelectorReferingClassVariable.! !

!PullUpMethodsToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 12/2/2013 16:58'!
rejectSelectorReferingClassVariable
	commonSelectors := commonSelectors reject: [ :each| classes anySatisfy: [ :cls| 
			cls classVarNames anySatisfy: [:cvn| (cls whichSelectorsReferTo: (cls bindingOf: cvn)) includes: each ]]].! !

!PullUpMethodsToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 12/2/2013 16:55'!
rejectSelectorsHavingPragmas
	commonSelectors := commonSelectors reject: [ :each| classes anySatisfy: [ :cls| (cls compiledMethodAt: each) pragmas notEmpty ] ].! !

!PullUpMethodsToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 12/2/2013 15:15'!
rejectSelectorsIfSourceCodeOfSuperclassAndSubclassIsDifferent
	commonSelectors := commonSelectors reject: [:sel| 
		(commonSuperclass selectors includes: sel) and: [ (commonSuperclass sourceCodeAt: sel) ~= (classes anyOne sourceCodeAt: sel) ]]! !

!PullUpMethodsToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 12/2/2013 16:52'!
rejectSuperSendingSelectors
	commonSelectors := commonSelectors reject: [ :each| classes anySatisfy: [ :cls| (cls compiledMethodAt: each) sendsToSuper ] ].! !

!PullUpMethodsToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 12/2/2013 15:01'!
rejectTraitMethods
	commonSelectors := commonSelectors select: [:sel| 
		classes allSatisfy: [:cls| cls includesLocalSelector: sel ] ]! !

!PullUpMethodsToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 12/2/2013 14:59'!
selectSelectorsSourceCodeOfAllSubclassesAreSame

	commonSelectors := commonSelectors select: [:sel| (classes collect: [:cls| cls sourceCodeAt: sel]) asSet size = 1 ].! !

Object subclass: #PullUpToSuperclass
	instanceVariableNames: 'classes commonSuperclass commonClassSideSelectors commonInstanceSideSelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PullUpToSuperclass'!

!PullUpToSuperclass commentStamp: 'HwaJong 5/3/2013 21:44' prior: 0!
m := PullUpToSuperclass new.
m commonSuperclass: Wooluspos.
m run.!

!PullUpToSuperclass class methodsFor: 'on image testing' stamp: 'HwaJong 1/19/2014 20:27'!
installSubjectPackage

	#(#traitSubjectPackageChunk  #threeSubclassSubjectPackageChunk  #oneSubclassSubjectPackageChunk)
		do: 
			[ :symbol| self installSubjectPackageWithChunkSelector: symbol].
	
	! !

!PullUpToSuperclass class methodsFor: 'on image testing' stamp: 'HwaJong 1/19/2014 20:26'!
installSubjectPackageWithChunkSelector: aSymbol
 
	|posStream|
	posStream := (self perform: aSymbol) readStream.
	{
		[ posStream fileInFor: nil announcing: 'WhoolaWhoolaWooWoo' ].
		[ posStream fileInAnnouncing: 'WhoolaWhoolaWooWoo' ].
		[ #CodeImporter ggGlobal evaluateReadStream: posStream ]
	} valueEitherWayAround.
	

! !

!PullUpToSuperclass class methodsFor: 'on image testing' stamp: 'HwaJong 1/19/2014 19:57'!
oneSubclassSubjectPackageChunk
	"get it from following line:

	CAUTION: get rid of methods added by Trait. FileOut does not check if method is from trait or not.
	
		Clipboard clipboardText asString"
^ 'Object subclass: #Wooluspos2
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo-oneSubclass''!!


Wooluspos2 subclass: #WoolOnlyOneSubclass
	instanceVariableNames: ''var1''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo-oneSubclass''!!

!!WoolOnlyOneSubclass methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/5/2013 16:33''!!
method1
	^self!! !!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

WoolOnlyOneSubclass class
	instanceVariableNames: ''''!!

!!WoolOnlyOneSubclass class methodsFor: ''as yet unclassified'' stamp: ''HwaJong 12/2/2013 10:54''!!
classMethod1
	^1!! !!
'! !

!PullUpToSuperclass class methodsFor: 'public' stamp: 'HwaJong 8/3/2013 00:47'!
runAfterCreatingSuperclassNamed: aSymbol forClasses: aCollection

	| supers newClass |
	supers := (aCollection collect: #superclass) asSet.
	[supers size = 1] assert.
	newClass := (supers anyOne) subclass: aSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: (aCollection anyOne category).
	
	aCollection do: [:each| each moveToSuperclassNamed: aSymbol ].
	
	self new
		commonSuperclass: newClass;
		run.! !

!PullUpToSuperclass class methodsFor: 'public' stamp: 'HwaJong 8/3/2013 00:41'!
runOnCommonSuperclass: aClass
	
	self new
		commonSuperclass: aClass;
		run.! !

!PullUpToSuperclass class methodsFor: 'on image testing' stamp: 'HwaJong 1/19/2014 20:20'!
runOnSubjectPackage 
	self new commonSuperclass: (Smalltalk classNamed: 'Wooluspos'); run.
	self new commonSuperclass: (Smalltalk classNamed: 'Wooluspos2'); run.
	self new commonSuperclass: (Smalltalk classNamed: 'Wooluspos3'); run.! !

!PullUpToSuperclass class methodsFor: 'on image testing' stamp: 'HwaJong 1/19/2014 19:58'!
threeSubclassSubjectPackageChunk
	"get it from following line:

	CAUTION: get rid of methods added by Trait. FileOut does not check if method is from trait or not.
	
		Clipboard clipboardText asString"
^ 'Object subclass: #Wooluspos
	instanceVariableNames: ''c''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo-threeSubclass''!!

!!Wooluspos methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/5/2013 10:16''!!
superClassDefinesThisDifferently
	^''superclass is super''!! !!


!!Wooluspos methodsFor: ''category1'' stamp: ''HwaJong 8/3/2013 12:16''!!
iShouldBeCategorizedTo1
	^self!! !!


!!Wooluspos methodsFor: ''category2'' stamp: ''HwaJong 8/3/2013 12:16''!!
iShouldBeCategorizedTo2
	^self!! !!


!!Wooluspos methodsFor: ''accessing'' stamp: ''HwaJong 8/3/2013 12:16''!!
c
	^ c!! !!

!!Wooluspos methodsFor: ''accessing'' stamp: ''HwaJong 8/3/2013 12:16''!!
c: anObject
	c := anObject!! !!


Wooluspos subclass: #WoolClass2
	instanceVariableNames: ''b d''
	classVariableNames: ''Keke''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo-threeSubclass''!!

!!WoolClass2 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
b
	^ b!! !!

!!WoolClass2 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
b: anObject
	b := anObject!! !!

!!WoolClass2 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
d
	^ d!! !!

!!WoolClass2 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
d: anObject
	d := anObject!! !!


!!WoolClass2 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 12/2/2013 16:24''!!
havingPragma
	<justADummpyPragma>!! !!

!!WoolClass2 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/4/2013 23:28''!!
referingToClassVarKeke

	Keke := 1004.!! !!

!!WoolClass2 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/3/2013 22:24''!!
sourceCodeIsNotExactlySame
	^''bye''!! !!

!!WoolClass2 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/5/2013 10:16''!!
superClassDefinesThisDifferently
	^''i am cool''!! !!

!!WoolClass2 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/4/2013 00:39''!!
superSends
	^super yourself!! !!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

WoolClass2 class
	instanceVariableNames: ''''!!

!!WoolClass2 class methodsFor: ''as yet unclassified'' stamp: ''HwaJong 12/2/2013 10:54''!!
classMethod3
	^3!! !!


Wooluspos subclass: #WoolClass3
	instanceVariableNames: ''a d''
	classVariableNames: ''Keke''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo-threeSubclass''!!

!!WoolClass3 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
a
	^ a!! !!

!!WoolClass3 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
a: anObject
	a := anObject!! !!

!!WoolClass3 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
d
	^ d!! !!

!!WoolClass3 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:22''!!
d: anObject
	d := anObject!! !!


!!WoolClass3 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 12/2/2013 16:24''!!
havingPragma
	<justADummpyPragma>!! !!

!!WoolClass3 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/4/2013 23:29''!!
referingToClassVarKeke

	Keke := 1004.!! !!

!!WoolClass3 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/3/2013 22:24''!!
sourceCodeIsNotExactlySame
	^''hello''!! !!

!!WoolClass3 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/5/2013 10:16''!!
superClassDefinesThisDifferently
	^''i am cool''!! !!

!!WoolClass3 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/4/2013 00:39''!!
superSends
	^super yourself!! !!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

WoolClass3 class
	instanceVariableNames: ''''!!

!!WoolClass3 class methodsFor: ''as yet unclassified'' stamp: ''HwaJong 12/2/2013 10:54''!!
classMethod3
	^3!! !!


Wooluspos subclass: #WoolClass1
	instanceVariableNames: ''a b''
	classVariableNames: ''Keke''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo-threeSubclass''!!

!!WoolClass1 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:21''!!
a
	^ a!! !!

!!WoolClass1 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:21''!!
a: anObject
	a := anObject!! !!

!!WoolClass1 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:21''!!
b
	^ b!! !!

!!WoolClass1 methodsFor: ''accessing'' stamp: ''HwaJong 5/3/2013 20:21''!!
b: anObject
	b := anObject!! !!


!!WoolClass1 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 12/2/2013 16:24''!!
havingPragma
	<justADummpyPragma>!! !!

!!WoolClass1 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/4/2013 23:30''!!
referingToClassVarKeke

	Keke := 1004.!! !!

!!WoolClass1 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/3/2013 22:24''!!
sourceCodeIsNotExactlySame
	^''hello''!! !!

!!WoolClass1 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/5/2013 10:16''!!
superClassDefinesThisDifferently
	^''i am cool''!! !!

!!WoolClass1 methodsFor: ''as yet unclassified'' stamp: ''HwaJong 5/4/2013 00:39''!!
superSends
	^super yourself!! !!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

WoolClass1 class
	instanceVariableNames: ''''!!

!!WoolClass1 class methodsFor: ''as yet unclassified'' stamp: ''HwaJong 12/2/2013 10:54''!!
classMethod3
	^3!! !!
'! !

!PullUpToSuperclass class methodsFor: 'on image testing' stamp: 'HwaJong 1/19/2014 20:16'!
traitSubjectPackageChunk
	"get it from following line:

	CAUTION: get rid of methods added by Trait. FileOut does not check if method is from trait or not.
	
		Clipboard clipboardText asString"
^  'Trait named: #WoolTrait
	uses: {}
	category: ''WhoolaWhoolaWooWoo-trait''!!

!!WoolTrait methodsFor: ''as yet unclassified'' stamp: ''HwaJong 8/3/2013 10:36''!!
traitMethod1
	^''t1''!! !!

!!WoolTrait methodsFor: ''as yet unclassified'' stamp: ''HwaJong 8/3/2013 10:36''!!
traitMethod2
	^''t2''!! !!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

WoolTrait classTrait
	uses: {}!!

!!WoolTrait classTrait methodsFor: ''as yet unclassified'' stamp: ''HwaJong 12/2/2013 10:53''!!
traitClassMethod
	^''tcm''!! !!


Object subclass: #Wooluspos3
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo-trait''!!


Wooluspos3 subclass: #WoolTraitUser2
	uses: WoolTrait
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo-trait''!!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

WoolTraitUser2 class
	uses: WoolTrait classTrait
	instanceVariableNames: ''''!!



Wooluspos3 subclass: #WoolTraitUser1
	uses: WoolTrait
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''WhoolaWhoolaWooWoo-trait''!!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

WoolTraitUser1 class
	uses: WoolTrait classTrait
	instanceVariableNames: ''''!!

'! !

!PullUpToSuperclass class methodsFor: 'on image testing' stamp: 'HwaJong 1/19/2014 20:22'!
uninstallSubjectPackage

	SystemOrganization removeCategoriesMatching: 'WhoolaWhoolaWooWoo-*'; removeEmptyCategories! !

!PullUpToSuperclass methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 21:43'!
commonSuperclass: aClass
	commonSuperclass := aClass! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 5/4/2013 00:50'!
getClasses
	classes := commonSuperclass subclasses.! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 3/18/2014 11:51'!
moveInstanceVariables

	|commonInstanceVariables|
	commonInstanceVariables := classes inject: classes anyOne instVarNames into: [:ivs :clss| ivs intersection: clss instVarNames].
	
	commonInstanceVariables do: 
		[ :ivarName |
		|map|
		map := IdentityDictionary new.
		classes do: 
			[:xClass| 
			xClass allSubInstances do: 
				[ :each|
				map at: each put: (each instVarNamed: ivarName) ]].
		(RBPullUpInstanceVariableRefactoring
			model: (RBNamespace onEnvironment: RBBrowserEnvironment new) variable: ivarName class: commonSuperclass) execute.		
		map keysAndValuesDo: 
			[ :obj :ivar |
			obj instVarNamed: ivarName put: ivar]].! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 12/2/2013 15:32'!
moveMethods

	(PullUpMethodsToSuperclass new
		classes: classes;
		commonSuperclass: commonSuperclass;
		moveMethods).
	(PullUpMethodsToSuperclass new
		classes: (classes collect: #class);
		commonSuperclass: commonSuperclass class;
		moveMethods)! !

!PullUpToSuperclass methodsFor: 'sub routine' stamp: 'HwaJong 5/4/2013 00:50'!
removeEmptyCategoriesForClasses
	classes do: [:each| each organization removeEmptyCategories ].! !

!PullUpToSuperclass methodsFor: 'main operation' stamp: 'HwaJong 5/5/2013 16:27'!
run
	self getClasses.
	classes size > 1
		ifTrue: 
			[self moveInstanceVariables.
			self moveMethods.
			self removeEmptyCategoriesForClasses].! !

TestCase subclass: #PullUpToSuperclassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PullUpToSuperclass'!

!PullUpToSuperclassTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/4/2013 12:38'!
tearDown
	PullUpToSuperclass uninstallSubjectPackage.
	Smalltalk garbageCollect.
	super tearDown.! !

!PullUpToSuperclassTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/18/2014 11:54'!
testWooluspos1
	| instance |
	PullUpToSuperclass installSubjectPackageWithChunkSelector: #threeSubclassSubjectPackageChunk.
	instance := (Smalltalk classNamed: #WoolClass1) new.
	instance c: 'instance variable to save'.
	self assert: instance c equals: 'instance variable to save'.
	PullUpToSuperclass runOnCommonSuperclass: (Smalltalk classNamed: #Wooluspos).
	self assert: instance c equals: 'instance variable to save'.
	self assert: (Smalltalk classNamed: #Wooluspos) instVarNames equals: #('c').
	self assert: (Smalltalk classNamed: #WoolClass1) instVarNames equals: #('a' 'b').
	self assert: (Smalltalk classNamed: #WoolClass2) instVarNames equals: #('b' 'd').
	self assert: (Smalltalk classNamed: #WoolClass3) instVarNames equals: #('a' 'd').
	
	self assert: (Smalltalk classNamed: #Wooluspos) selectors asSortedCollection equals: #(#iShouldBeCategorizedTo1 #c #superClassDefinesThisDifferently #iShouldBeCategorizedTo2 #c:) asSortedCollection.
	self assert: (Smalltalk classNamed: #WoolClass1) selectors asSortedCollection equals:  #(#a: #sourceCodeIsNotExactlySame #b #b: #superSends #superClassDefinesThisDifferently #a #referingToClassVarKeke #havingPragma) asSortedCollection.
	self assert: (Smalltalk classNamed: #WoolClass2) selectors asSortedCollection equals:  #(#sourceCodeIsNotExactlySame #d #b #b: #superSends #superClassDefinesThisDifferently #d: #referingToClassVarKeke #havingPragma) asSortedCollection.
	self assert: (Smalltalk classNamed: #WoolClass3) selectors asSortedCollection equals:  #(#a: #sourceCodeIsNotExactlySame #d #superSends #superClassDefinesThisDifferently #a #d: #referingToClassVarKeke #havingPragma) asSortedCollection.
	
	self assert: (((Smalltalk classNamed: #Wooluspos) compiledMethodAt: #iShouldBeCategorizedTo1) category) equals: #category1.
	self assert: (((Smalltalk classNamed: #Wooluspos) compiledMethodAt: #iShouldBeCategorizedTo2) category) equals: #category2.
	
	self assert: (Smalltalk classNamed: #Wooluspos) class selectors asSortedCollection equals: #(#classMethod3) asSortedCollection.
	self assert: (Smalltalk classNamed: #WoolClass1) class selectors asSortedCollection equals:  #() asSortedCollection.
	self assert: (Smalltalk classNamed: #WoolClass2) class selectors asSortedCollection equals:  #() asSortedCollection.
	self assert: (Smalltalk classNamed: #WoolClass3) class selectors asSortedCollection equals:  #() asSortedCollection.! !

!PullUpToSuperclassTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/19/2014 20:30'!
testWooluspos2
	PullUpToSuperclass installSubjectPackageWithChunkSelector: #oneSubclassSubjectPackageChunk.
	PullUpToSuperclass runOnCommonSuperclass: (Smalltalk classNamed: #Wooluspos2).
	self assert: (Smalltalk classNamed: #WoolOnlyOneSubclass) instVarNames equals: #('var1').
	self assert: ((Smalltalk classNamed: #WoolOnlyOneSubclass) selectors) equals: #(#method1).
	
	self assert: (Smalltalk classNamed: #Wooluspos2) instVarNames equals: #().
	self assert: ((Smalltalk classNamed: #Wooluspos2) selectors) equals: #().
	
	self assert: (Smalltalk classNamed: #Wooluspos2) class selectors asSortedCollection equals: #() asSortedCollection.
	self assert: (Smalltalk classNamed: #WoolOnlyOneSubclass) class selectors asSortedCollection equals:  #(#classMethod1) asSortedCollection.! !

!PullUpToSuperclassTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/19/2014 20:30'!
testWooluspos3
	PullUpToSuperclass installSubjectPackageWithChunkSelector: #traitSubjectPackageChunk.
	PullUpToSuperclass runOnCommonSuperclass: (Smalltalk classNamed: #Wooluspos3).
	self assert: (Smalltalk classNamed: #Wooluspos3) instVarNames equals: #().
	self assert: ((Smalltalk classNamed: #Wooluspos3) selectors) equals: #().
	self assert: ((Smalltalk classNamed: #Wooluspos3) class selectors) equals: #().! !
